Mathematical Mesh 3.0 Part IX Security Considerations
Internet-Draft draft-hallambaker-mesh-security
Phillip Hallam-Baker
ThresholdSecrets.com
phill@hallambaker.com
20 April 2022
The Mathematical Mesh 'The Mesh' is an end-to-end secure infrastructure that facilitates the exchange of configuration and credential data between multiple user devices. The core protocols of the Mesh are described with examples of common use cases and reference data.
[Note to Readers]
Discussion of this draft takes place on the MATHMESH mailing list (mathmesh@ietf.org), which is archived at https://mailarchive.ietf.org/arch/search/?email_list=mathmesh.
This document is also available online at http://mathmesh.com/Documents/draft-hallambaker-mesh-security.html.

Introduction

Definitions
This section presents the related specifications and standard, the terms that are used as terms of art within the documents and the terms used as requirements language.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [RFC2119].

Defined Terms
The terms of art used in this document are described in the Mesh Architecture Guide [draft-hallambaker-mesh-architecture].

Related Specifications
The architecture of the Mathematical Mesh is described in the Mesh Architecture Guide [draft-hallambaker-mesh-architecture]. The Mesh documentation set and related specifications are described in this document.

Implementation Status
The implementation status of the reference code base is described in the companion document [draft-hallambaker-mesh-developer].

Shared Classes
The following classes are used as common elements in Mesh profile specifications.

Classes describing keys

Structure: KeyData
The KeyData class is used to describe public key pairs and trust assertions associated with a public key.
Udf: String (Optional)
UDF fingerprint of the public key parameters
X509Certificate: Binary (Optional)
List of X.509 Certificates
X509Chain: Binary [0..Many]
X.509 Certificate chain.
X509CSR: Binary (Optional)
X.509 Certificate Signing Request.
NotBefore: DateTime (Optional)
If present specifies a time instant that use of the private key is not valid before.
NotOnOrAfter: DateTime (Optional)
If present specifies a time instant that use of the private key is not valid on or after.

Structure: CompositePrivate
Inherits: Key
DeviceKeyUdf: String (Optional)
UDF fingerprint of the bound device key (if used).

Assertion classes
Classes that are derived from an assertion.

Structure: Assertion
Parent class from which all assertion classes are derived
Names: String [0..Many]
Fingerprints of index terms for profile retrieval. The use of the fingerprint of the name rather than the name itself is a precaution against enumeration attacks and other forms of abuse.
Updated: DateTime (Optional)
The time instant the profile was last modified.
NotaryToken: String (Optional)
A Uniform Notary Token providing evidence that a signature was performed after the notary token was created.

Structure: Condition
Parent class from which all condition classes are derived.
[No fields]

Base Classes
Abstract classes from which the Profile, Activation and Connection classes are derrived.

Structure: Connection
Inherits: Assertion
SubjectUdf: String (Optional)
UDF of the connection target.
AuthorityUdf: String (Optional)
UDF of the connection source.

Structure: Activation
Inherits: Assertion
Contains the private activation information for a Mesh application running on a specific device
ActivationKey: String (Optional)
Secret seed used to derive keys that are not explicitly specified.
Entries: ActivationEntry [0..Many]
Activation of named resources.

Structure: ActivationEntry
Resource: String (Optional)
Name of the activated resource
Key: KeyData (Optional)
The activation key or key share

Mesh Profile Classes
Classes describing Mesh Profiles. All Profiles are Assertions derrived from Assertion.

Structure: Profile
Inherits: Assertion
Parent class from which all profile classes are derived
ProfileSignature: KeyData (Optional)
The permanent signature key used to sign the profile itself. The UDF of the key is used as the permanent object identifier of the profile. Thus, by definition, the KeySignature value of a Profile does not change under any circumstance.

Structure: ProfileDevice
Inherits: Profile
Describes a mesh device.
Description: String (Optional)
Description of the device
BaseEncryption: KeyData (Optional)
Base key contribution for encryption keys. Also used to decrypt activation data sent to the device during connection to an account.
BaseAuthentication: KeyData (Optional)
Base key contribution for authentication keys. Also used to authenticate the device during connection to an account.
BaseSignature: KeyData (Optional)
Base key contribution for signature keys.

Structure: ProfileAccount
Base class for the account profiles ProfileUser and ProfileGroup. These subclasses may be merged at some future date.
Inherits: Profile
AccountAddress: String (Optional)
The account address. This is either a DNS service address (e.g. alice@example.com) or a Mesh Name (@alice).
ServiceUdf: String (Optional)
The fingerprint of the service profile to which the account is currently bound.
EscrowEncryption: KeyData (Optional)
Escrow key associated with the account.
AccountEncryption: KeyData (Optional)
Key currently used to encrypt data under this profile
AdministratorSignature: KeyData (Optional)
Key used to sign connection assertions to the account.

Structure: ProfileUser
Inherits: ProfileAccount
Account assertion. This is signed by the service hosting the account.
AccountAuthentication: KeyData (Optional)
Key used to authenticate requests made under this user account.
AccountSignature: KeyData (Optional)
Key used to sign data under the account.

Structure: ProfileGroup
Inherits: ProfileAccount
Describes a group. Note that while a group is created by one person who becomes its first administrator, control of the group may pass to other administrators over time.
[No fields]

Structure: ProfileService
Inherits: Profile
Profile of a Mesh Service
ServiceAuthentication: KeyData (Optional)
Key used to authenticate service connections.
ServiceEncryption: KeyData (Optional)
Key used to encrypt data under this profile
ServiceSignature: KeyData (Optional)
Key used to sign data under the account.

Structure: ProfileHost
Inherits: Profile
KeyAuthentication: KeyData (Optional)
Key used to authenticate service connections.
KeyEncryption: KeyData (Optional)
Key used to pass encrypted data to the device such as a

Connection Assertions
Connection assertions are used to authenticate and authorize interactions between devices and the service currently servicing the account. They SHOULD NOT be visible to external parties.

Structure: ConnectionDevice
Inherits: Connection
Connection assertion used to authenticate service requests made by a device.
AccountAddress: String (Optional)
The account address
DeviceSignature: KeyData (Optional)
The signature key for use of the device under the profile
DeviceEncryption: KeyData (Optional)
The encryption key for use of the device under the profile
DeviceAuthentication: KeyData (Optional)
The authentication key for use of the device under the profile

Structure: ConnectionApplication
Inherits: Connection
Connection assertion stating that a particular device is
[No fields]

Structure: ConnectionGroup
Describes the connection of a member to a group.
Inherits: Connection
[No fields]

Structure: ConnectionService
Inherits: Connection
[No fields]

Structure: ConnectionHost
Inherits: Connection
[No fields]

Activation Assertions

Structure: ActivationDevice
Contains activation data for device specific keys used in the context of a Mesh account.
Inherits: Activation
AccountUdf: String (Optional)
The UDF of the account

Structure: ActivationAccount
Inherits: Activation
ProfileSignature: KeyData (Optional)
Grant access to profile online signing key used to sign updates to the profile.
AdministratorSignature: KeyData (Optional)
Grant access to Profile administration key used to make changes to administrator catalogs.
AccountEncryption: KeyData (Optional)
Grant access to ProfileUser account encryption key
AccountAuthentication: KeyData (Optional)
Grant access to ProfileUser account authentication key
AccountSignature: KeyData (Optional)
Grant access to ProfileUser account signature key

Structure: ActivationApplication
Inherits: Activation
[No fields]

Data Structures
Classes describing data used in cataloged data.

Structure: Contact
Inherits: Assertion
Base class for contact entries.
Id: String (Optional)
The globally unique contact identifier.
Anchors: Anchor [0..Many]
Mesh fingerprints associated with the contact.
NetworkAddresses: NetworkAddress [0..Many]
Network address entries
Locations: Location [0..Many]
The physical locations the contact is associated with.
Roles: Role [0..Many]
The roles of the contact
Bookmark: Bookmark [0..Many]
The Web sites and other online presences of the contact
Sources: TaggedSource [0..Many]
Source(s) from which this contact was constructed.

Structure: Anchor
Trust anchor
Udf: String (Optional)
The trust anchor.
Validation: String (Optional)
The means of validation.

Structure: TaggedSource
Source from which contact information was obtained.
LocalName: String (Optional)
Short name for the contact information.
Validation: String (Optional)
The means of validation.
BinarySource: Binary (Optional)
The contact data in binary form.
EnvelopedSource: Enveloped (Optional)
The contact data in enveloped form. If present, the BinarySource property is ignored.

Structure: ContactGroup
Inherits: Contact
Contact for a group, including encryption groups.
[No fields]

Structure: ContactPerson
Inherits: Contact
CommonNames: PersonName [0..Many]
List of person names in order of preference

Structure: ContactOrganization
Inherits: Contact
CommonNames: OrganizationName [0..Many]
List of person names in order of preference

Structure: OrganizationName
The name of an organization
Inactive: Boolean (Optional)
If true, the name is not in current use.
RegisteredName: String (Optional)
The registered name.
DBA: String (Optional)
Names that the organization uses including trading names and doing business as names.

Structure: PersonName
The name of a natural person
Inactive: Boolean (Optional)
If true, the name is not in current use.
FullName: String (Optional)
The preferred presentation of the full name.
Prefix: String (Optional)
Honorific or title, E.g. Sir, Lord, Dr., Mr.
First: String (Optional)
First name.
Middle: String [0..Many]
Middle names or initials.
Last: String (Optional)
Last name.
Suffix: String (Optional)
Nominal suffix, e.g. Jr., III, etc.
PostNominal: String (Optional)
Post nominal letters (if used).

Structure: NetworkAddress
Provides all means of contacting the individual according to a particular network address
Inactive: Boolean (Optional)
If true, the name is not in current use.
Address: String (Optional)
The network address, e.g. alice@example.com
NetworkCapability: String [0..Many]
The capabilities bound to this address.
EnvelopedProfileAccount: Enveloped (Optional)
The account profile
Protocols: NetworkProtocol [0..Many]
Public keys associated with the network address

Structure: NetworkProtocol
Protocol: String (Optional)
The IANA protocol|identifier of the network protocols by which the contact may be reached using the specified Address.

Structure: Role
OrganizationName: String (Optional)
The organization at which the role is held
Titles: String [0..Many]
The titles held with respect to that organization.
Locations: Location [0..Many]
Postal or physical addresses associated with the role.

Structure: Location
Appartment: String (Optional)
Street: String (Optional)
District: String (Optional)
Locality: String (Optional)
County: String (Optional)
Postcode: String (Optional)
Country: String (Optional)

Structure: Bookmark
Uri: String (Optional)
Title: String (Optional)
Role: String [0..Many]

Structure: Reference
MessageId: String (Optional)
The received message to which this is a response
ResponseId: String (Optional)
Message that was generated in response to the original (optional).
Relationship: String (Optional)
The relationship type. This can be Read, Unread, Accept, Reject.

Structure: Task
Key: String (Optional)
Unique key.
Start: DateTime (Optional)
Finish: DateTime (Optional)
StartTravel: String (Optional)
FinishTravel: String (Optional)
TimeZone: String (Optional)
Title: String (Optional)
Description: String (Optional)
Location: String (Optional)
Trigger: String [0..Many]
Conference: String [0..Many]
Repeat: String (Optional)
Busy: Boolean (Optional)

Catalog Entries

Structure: CatalogedEntry
Base class for cataloged Mesh data.
Labels: String [0..Many]
The set of labels describing the entry

Structure: CatalogedDevice
Inherits: CatalogedEntry
Public device entry, indexed under the device ID Hello
Udf: String (Optional)
UDF of the signature key of the device in the Mesh
DeviceUdf: String (Optional)
UDF of the offline signature key of the device
SignatureUdf: String (Optional)
UDF of the account online signature key
EnvelopedProfileUser: Enveloped (Optional)
The Mesh profile
EnvelopedProfileDevice: Enveloped (Optional)
The device profile
EnvelopedConnectionUser: Enveloped (Optional)
The public assertion demonstrating connection of the Device to the Mesh
EnvelopedActivationDevice: Enveloped (Optional)
The activation of the device within the Mesh account
EnvelopedActivationAccount: Enveloped (Optional)
The activation of the device within the Mesh account
EnvelopedActivationApplication: Enveloped [0..Many]
Application activations granted to the device.

Structure: CatalogedPublication
Inherits: CatalogedEntry
A publication.
Id: String (Optional)
Unique identifier code
Authenticator: String (Optional)
The witness key value to use to request access to the record.
EnvelopedData: DareEnvelope (Optional)
Dare Envelope containing the entry data. The data type is specified by the envelope metadata.
NotOnOrAfter: DateTime (Optional)
Epiration time (inclusive)

Structure: CatalogedCredential
Inherits: CatalogedEntry
Protocol: String (Optional)
Service: String (Optional)
Username: String (Optional)
Password: String (Optional)

Structure: CatalogedNetwork
Inherits: CatalogedEntry
Protocol: String (Optional)
Service: String (Optional)
Username: String (Optional)
Password: String (Optional)

Structure: CatalogedContact
Inherits: CatalogedEntry
Key: String (Optional)
Unique key.
Self: Boolean (Optional)
If true, this catalog entry is for the user who created the catalog.

Structure: CatalogedAccess
Inherits: CatalogedEntry
[No fields]

Structure: CryptographicCapability
Id: String (Optional)
The identifier of the capability. If this is a user capability, MUST match the KeyData identifier. If this is a serviced capability, MUST match the value of ServiceId on the corresponding service capability.
KeyData: KeyData (Optional)
The key that enables the capability
EnvelopedKeyShares: Enveloped [0..Many]
One or more enveloped key shares.
SubjectId: String (Optional)
The identifier of the resource that is controlled using the key.
SubjectAddress: String (Optional)
The address of the resource that is controlled using the key.

Structure: CapabilityDecrypt
Inherits: CryptographicCapability
The corresponding key is a decryption key
[No fields]

Structure: CapabilityDecryptPartial
Inherits: CapabilityDecrypt
The corresponding key is an encryption key
ServiceId: String (Optional)
The identifier used to claim the capability from the service.[Only present for a partial capability.]
ServiceAddress: String (Optional)
The service account that supports a serviced capability. [Only present for a partial capability.]

Structure: CapabilityDecryptServiced
Inherits: CapabilityDecrypt
The corresponding key is an encryption key
AuthenticationId: String (Optional)
UDF of trust root under which request to use a serviced capability must be authorized. [Only present for a serviced capability]

Structure: CapabilitySign
Inherits: CryptographicCapability
The corresponding key is an administration key
[No fields]

Structure: CapabilityKeyGenerate
Inherits: CryptographicCapability
The corresponding key is a key that may be used to generate key shares.
[No fields]

Structure: CapabilityFairExchange
Inherits: CryptographicCapability
The corresponding key is a decryption key to be used in accordance with the Micali Fair Electronic Exchange with Invisible Trusted Parties protocol.
[No fields]

Structure: CatalogedBookmark
Inherits: CatalogedEntry
Uri: String (Optional)
Title: String (Optional)
Path: String (Optional)

Structure: CatalogedTask
Inherits: CatalogedEntry
EnvelopedTask: Enveloped (Optional)
Title: String (Optional)
Key: String (Optional)
Unique key.

Structure: CatalogedApplication
Inherits: CatalogedEntry
Key: String (Optional)
EnvelopedCapabilities: DareEnvelope [0..Many]
Enveloped keys for use with Application

Structure: CatalogedMember
ContactAddress: String (Optional)
MemberCapabilityId: String (Optional)
ServiceCapabilityId: String (Optional)
Inherits: CatalogedEntry

Structure: CatalogedGroup
Inherits: CatalogedApplication
EnvelopedProfileGroup: Enveloped (Optional)
The Mesh profile
EnvelopedActivationAccount: Enveloped (Optional)
The activation of the device within the Mesh account

Structure: CatalogedApplicationSSH
Inherits: CatalogedApplication
[No fields]

Structure: CatalogedApplicationMail
Inherits: CatalogedApplication
[No fields]

Structure: CatalogedApplicationNetwork
Inherits: CatalogedApplication
[No fields]

Publications

Structure: DevicePreconfiguration
A data structure that is passed
EnvelopedProfileDevice: Enveloped (Optional)
The device profile
EnvelopedConnectionDevice: Enveloped (Optional)
The device connection
ConnectUri: String (Optional)
The connection URI. This would normally be printed on the device as a QR code.

Messages

Structure: Message
MessageId: String (Optional)
Unique per-message ID. When encapsulating a Mesh Message in a DARE envelope, the envelope EnvelopeID field MUST be a UDF fingerprint of the MessageId value.
Sender: String (Optional)
Recipient: String (Optional)

Structure: MessageError
Inherits: Message
ErrorCode: String (Optional)

Structure: MessageComplete
Inherits: Message
References: Reference [0..Many]

Structure: MessagePinValidated
Inherits: Message
AuthenticatedData: DareEnvelope (Optional)
Enveloped data that is authenticated by means of the PIN
ClientNonce: Binary (Optional)
Nonce provided by the client to validate the PIN
PinId: String (Optional)
Pin identifier value calculated from the PIN code, action and account address.
PinWitness: Binary (Optional)
Witness value calculated as KDF (Device.Udf + AccountAddress, ClientNonce)

Structure: MessagePin
Account: String (Optional)
Inherits: Message
Expires: DateTime (Optional)
Automatic: Boolean (Optional)
If true, authentication against the PIN code is sufficient to complete the associated action without further authorization.
SaltedPin: String (Optional)
PIN code bound to the specified action.
Action: String (Optional)
The action to which this PIN code is bound.

Structure: RequestConnection
Connection request message. This message contains the information
Inherits: MessagePinValidated
AccountAddress: String (Optional)

Structure: AcknowledgeConnection
Connection request message generated by a service on receipt of a valid MessageConnectionRequestClient
Inherits: Message
EnvelopedRequestConnection: Enveloped (Optional)
The client connection request.
ServerNonce: Binary (Optional)
Witness: String (Optional)

Structure: RespondConnection
Respond to RequestConnection message to grant or refuse the connection request.
Inherits: Message
Result: String (Optional)
The response to the request. One of "Accept", "Reject" or "Pending".
CatalogedDevice: CatalogedDevice (Optional)
The device information. MUST be present if the value of Result is "Accept". MUST be absent or null otherwise.

Structure: MessageContact
Inherits: MessagePinValidated
Reply: Boolean (Optional)
If true, requests that the recipient return their own contact information in reply.
Subject: String (Optional)
Optional explanation of the reason for the request.
PIN: String (Optional)
One time authentication code supplied to a recipient to allow authentication of the response.

Structure: GroupInvitation
Inherits: Message
Text: String (Optional)

Structure: RequestConfirmation
Inherits: Message
Text: String (Optional)

Structure: ResponseConfirmation
Inherits: Message
Request: Enveloped (Optional)
Accept: Boolean (Optional)

Structure: RequestTask
Inherits: Message
[No fields]

Structure: MessageClaim
Inherits: Message
PublicationId: String (Optional)
ServiceAuthenticate: String (Optional)
DeviceAuthenticate: String (Optional)
Expires: DateTime (Optional)

Structure: ProcessResult
For future use, allows logging of operations and results
Inherits: Message
Success: Boolean (Optional)
ErrorReport: String (Optional)
The error report code.

Mesh Portal Service Reference
HTTP Well Known Service Prefix: /.well-known/mmm
Every Mesh Portal Service transaction consists of exactly one request followed by exactly one response. Mesh Service transactions MAY cause modification of the data stored in the Mesh Portal or the Mesh itself but do not cause changes to the connection state. The protocol itself is thus idempotent. There is no set sequence in which operations are required to be performed. It is not necessary to perform a Hello transaction prior to a ValidateAccount, Publish or any other transaction.

Request Messages
A Mesh Portal Service request consists of a payload object that inherits from the MeshRequest class. When using the HTTP binding, the request MUST specify the portal DNS address in the HTTP Host field.

Message: MeshRequest
Base class for all request messages.
Portal: String (Optional)
Name of the Mesh Portal Service to which the request is directed.

Response Messages
A Mesh Portal Service response consists of a payload object that inherits from the MeshResponse class. When using the HTTP binding, the response SHOULD report the Status response code in the HTTP response message. However the response code returned in the payload object MUST always be considered authoritative.

Message: MeshResponse
Base class for all response messages. Contains only the status code and status description fields.
[No fields]

Imported Objects
The Mesh Service protocol makes use of JSON objects defined in the JOSE Signatgure and Encryption specifications.

Common Structures
The following common structures are used in the protocol messages:

Structure: KeyValue
Describes a Key/Value structure used to make queries for records matching one or more selection criteria.
Key: String (Optional)
The data retrieval key.
Value: String (Optional)
The data value to match.

Structure: SearchConstraints
Specifies constraints to be applied to a search result. These allow a client to limit the number of records returned, the quantity of data returned, the earliest and latest data returned, etc.
NotBefore: DateTime (Optional)
Only data published on or after the specified time instant is requested.
Before: DateTime (Optional)
Only data published before the specified time instant is requested. This excludes data published at the specified time instant.
MaxEntries: Integer (Optional)
Maximum number of data entries to return.
MaxBytes: Integer (Optional)
Maximum number of data bytes to return.
PageKey: String (Optional)
Specifies a page key returned in a previous search operation in which the number of responses exceeded the specified bounds.
When a page key is specified, all the other search parameters except for MaxEntries and MaxBytes are ignored and the service returns the next set of data responding to the earlier query.

Transaction: Hello
Request: HelloRequest
Response: HelloResponse
Report service and version information.
The Hello transaction provides a means of determining which protocol versions, message encodings and transport protocols are supported by the service.

Transaction: ValidateAccount
Request: ValidateRequest
Response: ValidateResponse
Request validation of a proposed name for a new account.
For validation of a user's account name during profile creation.

Message: ValidateRequest
Inherits: MeshRequest
Describes the proposed account properties. Currently, these are limited to the account name but could be extended in future versions of the protocol.
Account: String (Optional)
Account name requested
Reserve: Boolean (Optional)
If true, request a reservation for the specified account name. Note that the service is not obliged to honor reservation requests.
Language: String [0..Many]
List of ISO language codes in order of preference. For creating explanatory text.

Message: ValidateResponse
Inherits: MeshResponse
States whether the proposed account properties are acceptable and (optional) returns an indication of what properties are valid.
Note that receiving a 'Valid' responseto a Validate Request does not guarantee creation of the account. In addition to the possibility that the account namecould be requested by another user between the Validate and Create transactions, a portal service MAY perform more stringent validation criteria when an account is actually being created. For example, checking with the authoritative list of current accounts rather than a cached copy.
Valid: Boolean (Optional)
If true, the specified account identifier is acceptable. If false, the account identifier is rejected.
Minimum: Integer (Optional)
Specifies the minimum length of an account name.
Maximum: Integer (Optional)
Specifies the maximum length of an account name.
InvalidCharacters: String (Optional)
A list of characters that the service does not accept in account names. The list of characters MAY not be exhaustive but SHOULD include any illegal characters in the proposed account name.
Reason: String (Optional)
Text explaining the reason an account name was rejected.

Transaction: CreateAccount
Request: CreateRequest
Response: CreateResponse
Request creation of a new portal account.
Unlike a profile, a mesh account is specific to a particular Mesh portal. A mesh account must be created and accepted before a profile can be published.

Message: CreateRequest
Request creation of a new portal account. The request specifies the requested account identifier and the Mesh profile to be associated with the account.
Inherits: MeshRequest
Account: String (Optional)
Account identifier requested.

Message: CreateResponse
Inherits: MeshResponse
Reports the success or failure of a Create transaction.
[No fields]

Transaction: DeleteAccount
Request: DeleteRequest
Response: DeleteResponse
Request deletion of a portal account.
Deletes a portal account but not the underlying profile. Once registered, profiles are permanent.

Message: DeleteRequest
Request deletion of a new portal account. The request specifies the requested account identifier.
Inherits: MeshRequest
Account: String (Optional)
Account identifier to be deleted.

Message: DeleteResponse
Inherits: MeshResponse
Reports the success or failure of a Delete transaction.
[No fields]

Transaction: Get
Request: GetRequest
Response: GetResponse
Search for data in the mesh that matches a set of properties described by a sequence of key/value pairs.

Message: GetRequest
Describes the Portal or Mesh data to be retreived.
Inherits: MeshRequest
Identifier: String (Optional)
Lookup by profile ID
Account: String (Optional)
Lookup by Account ID
KeyValues: KeyValue [0..Many]
List of KeyValue pairs specifying the conditions to be met
SearchConstraints: SearchConstraints (Optional)
Constrain the search to a specific time interval and/or limit the number and/or total size of data records returned.
Multiple: Boolean (Optional)
If true return multiple responses if available
Full: Boolean (Optional)
If true, the client requests that the full Mesh data record be returned containing both the Mesh entry itself and the Mesh metadata that allows the date and time of the publication of the Mesh entry to be verified.

Message: GetResponse
Reports the success or failure of a Get transaction. If a Mesh entry matching the specified profile is found, containsthe list of entries matching the request.
Inherits: MeshResponse
DataItems: DataItem [0..Many]
List of mesh data records matching the request.
PageKey: String (Optional)
If non-null, indicates that the number and/or size of the data records returned exceeds either the SearchConstraints specified in the request or internal server limits.

Transaction: Publish
Request: PublishRequest
Response: PublishResponse
Publish a profile or key escrow entry to the mesh.

Message: PublishRequest
Requests publication of the specified Mesh entry.
Inherits: MeshRequest
[No fields]

Message: PublishResponse
Reports the success or failure of a Publish transaction.
Inherits: MeshResponse
[No fields]

Transaction: Status
Request: StatusRequest
Response: StatusResponse
Request the current status of the mesh as seen by the portal to which it is directed.
The response to the status request contains the last signed checkpoint and proof chains for each of the peer portals that have been checkpointed.
[Not currently implemented]

Message: StatusRequest
Inherits: MeshRequest
Initiates a status transaction.
[No fields]

Message: StatusResponse
Reports the success or failure of a Status transaction.
Inherits: MeshResponse
LastWriteTime: DateTime (Optional)
Time that the last write update was made to the Mesh
LastCheckpointTime: DateTime (Optional)
Time that the last Mesh checkpoint was calculated.
NextCheckpointTime: DateTime (Optional)
Time at which the next Mesh checkpoint should be calculated.
CheckpointValue: String (Optional)
Last checkpoint value.

Transaction: ConnectStart
Request: ConnectStartRequest
Response: ConnectStartResponse
Request connection of a new device to a mesh profile

Message: ConnectStartRequest
Inherits: MeshRequest
Initial device connection request.
SignedRequest: SignedConnectionRequest (Optional)
Device connection request signed by thesignature key of the device requesting connection.
AccountID: String (Optional)
Account identifier of account to which the device is requesting connection.

Message: ConnectStartResponse
Reports the success or failure of a ConnectStart transaction.
Inherits: MeshRequest
[No fields]

Transaction: ConnectStatus
Request: ConnectStatusRequest
Response: ConnectStatusResponse
Request status of pending connection request of a new device to a mesh profile

Message: ConnectStatusRequest
Inherits: MeshRequest
Request status information for a pending request posted previously.
AccountID: String (Optional)
Account identifier for which pending connection information is requested.
DeviceID: String (Optional)
Device identifier of device requesting status information.

Message: ConnectStatusResponse
Reports the success or failure of a ConnectStatus transaction.
Inherits: MeshRequest
Result: SignedConnectionResult (Optional)
The signed ConnectionResult object.

Transaction: ConnectPending
Request: ConnectPendingRequest
Response: ConnectPendingResponse
Request a list of pending requests for an administration profile.

Message: ConnectPendingRequest
Inherits: MeshRequest
Specify the criteria for pending requests.
AccountID: String (Optional)
The account identifier of the account for which pending connection requests are requested.
SearchConstraints: SearchConstraints (Optional)
Constrain the search to a specific time interval and/or limit the number and/or total size of data records returned.

Message: ConnectPendingResponse
Reports the success or failure of a ConnectPending transaction.
Inherits: MeshRequest
Pending: SignedConnectionRequest [0..Many]
A list of pending requests satisfying the criteria set out in the request.
PageKey: String (Optional)
If non-null, indicates that the number and/or size of the data records returned exceeds either the SearchConstraints specified in the request or internal server limits.

Transaction: ConnectComplete
Request: ConnectCompleteRequest
Response: ConnectCompleteResponse
Post response to a pending connection request.

Message: ConnectCompleteRequest
Reports the success or failure of a ConnectComplete transaction.
Inherits: MeshRequest
Result: SignedConnectionResult (Optional)
The connection result to be posted to the portal. The result MUST be signed by a valid administration key for the Mesh profile.
AccountID: String (Optional)
The account identifier to which the connection result is posted.

Message: ConnectCompleteResponse
Inherits: MeshRequest
Reports the success or failure of a ConnectComplete transaction.
[No fields]

Transaction: Transfer
Request: TransferRequest
Response: TransferResponse
Perform a bulk transfer of the log between the specified transaction identifiers. Requires appropriate authorization
[Not currently implemented]

Message: TransferRequest
Request a bulk transfer of the log between the specified transaction identifiers. Requires appropriate authorization
Inherits: MeshRequest
SearchConstraints: SearchConstraints (Optional)
Constrain the search to a specific time interval and/or limit the number and/or total size of data records returned.

Message: TransferResponse
Inherits: MeshResponse
Reports the success or failure of a Transfer transaction. If successful, contains the list of Mesh records to be transferred.
DataItems: DataItem [0..Many]
List of mesh data records matching the request.
PageKey: String (Optional)
If non-null, indicates that the number and/or size of the data records returned exceeds either the SearchConstraints specified in the request or internal server limits.

Assets

Data

Credentials

Reputation

Outbound Messaging Abuse ()

Risks

Confidentiality
Is a regulatory requirement GDPR/HIPPA

Privacy
Stronger requirement, given data but with restrictions on use
Unintended use within an organization may put it in default
GDPR
HIPPA

Integrity
Modification of data enables control breaches

Availability

Data loss
Loss of the pictures of the kids at 5

Partial data survivability
Where they buried Aunt Agatha's jewelry but not where they buried Aunt Agatha.

Inbound Messaging Abuse (Spam)

Threats

End point Compromise

Controls

Cryptographic

Triple lock

Transport Security
Traffic analysis protection

Message Security
Access control
Authentication / Integrity

Data Level Security
Data Confidentiality
Non-Repudiation

Key Protection
Use of platform provided facilities to bind private keys in the Device profile to the device is highly desirable. Ideally, private keys should be protected against extraction by hardware techniques presenting a high degree of resistance.

Windows
Use encrypted key store
Preferably use BitLocker

OSX
Use Key Ring

iOS
Use ???

Linux
Use the DBUS mechanism

Android
Hope and prayers.

Key and Nonce Generation
Use strong mechanisms as described in RFC???
Use of key co-generation as described in part 8 is advised

Key Escrow and Recovery
Master profile keys should be escrowed
Escrow strategies for DARE should take account of the fact that users may want some but not all their data assets to survive them.

Profile Verification
Check that the device credential has been signed by an administration device and that the administration device was properly authorized by the master profile.
Device catalog MUST be signed by the admin device.
Future ? provide protection against rollback attacks.

Identity Validation
See the separate document on the trust model

Trust Broker Accountability
Cert transparency type techniques

Mesh Messaging

Ingress Control
Every message is subject to access control
Mesh Services should perform abuse filtering on inbound mail
Mesh Services MUST apply user specified ingress control as specified in their contacts catalog.

Egress Control
Some applications may require egress control
For example, classified environments
Mail too stupid to send

Security Signal
Confirmation messages requiring payments
Need Accountability
Need to know the source of the accountability assertions
Should be distinguished from sender controlled part of a message

Brand
If messages are being sent on behalf of a corporate entity, this should be signaled to both sender and receiver
Sender ? remind them that they are speaking on behalf of another party
Receiver ? establish who is speaking by the familiar technique.

Accountability
Authentication and consequences

Security Considerations
This document comprises the security considerations for the use and implementation of the Mathematical Mesh.

Integrity

DNS Spoofing

TLS Downgrade

TLS Service Impersonation

Request Replay Attack

Response Replay Attack

Confidentiality

Side Channel Attack

Session Key Leakage

IANA Considerations
All the IANA considerations for the Mesh documents are specified in this document

Acknowledgements
A list of people who have contributed to the design of the Mesh is presented in [draft-hallambaker-mesh-architecture].

Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[draft-hallambaker-mesh-architecture]

Mathematical Mesh 3.0 Part I: Architecture Guide
Phillip Hallam-Baker
ThresholdSecrets.com
25 October 2021
Internet-Draft draft-hallambaker-mesh-architecture-19

Informative References
[draft-hallambaker-mesh-developer]

Mathematical Mesh: Reference Implementation
Phillip Hallam-Baker
27 July 2020
Internet-Draft draft-hallambaker-mesh-developer-10